<template>
  <div class="search-bar">
    <input
      v-model="text"
      class="search-table"
      type="search"
      :placeholder="placeholder"
    >
  </div>
</template>

<script>
import { mapState, mapMutations } from 'vuex';

import _ from 'lodash';

export default {
  name: 'SearchTable',

  props: {
    placeholder: {
      type: String,
      default: ''
    },
    searchFunction: {
      type: Function,
      default: () => { return {} }
    }
  },

  data() {
    return {
      text: null
    };
  },

  computed: {
    ...mapState('users', [
      'isUsersListSearched',
      'searchUsersFilter'
    ]),
    ...mapState('organisations', [
      'isOrganisationsListSearched',
      'searchOrganisationsFilter'
    ]),
    ...mapState('datasets', [
      'searchDatasetsFilter',
      'isDatasetsListSearched',
      'isPermissionsListSearched',
      'searchPermissionsFilter'
    ])
  },

  watch: {
    text: _.debounce(function(newValue) {
      this.$emit('loading', true);
      this.SET_CURRENT_PAGE(1);
      this.searchFunction({ text: newValue, types: [] }).then(() => {
        this.$emit('loading', false);
      });
    }, 100)
  },

  created() {
    this.RESET_CANCELLABLE_SEARCH_REQUEST();
    if (this.isUsersListSearched && this.$router.currentRoute.name === 'Users') {
      this.text = this.searchUsersFilter;
    }
    if (this.isOrganisationsListSearched && this.$router.currentRoute.name === 'Organisations') {
      this.text = this.searchOrganisationsFilter;
    }
    if (this.isPermissionsListSearched && this.$router.currentRoute.name === 'DatasetPermissions') {
      this.text = this.searchPermissionsFilter;
    }
    if (this.isDatasetsListSearched && this.$router.currentRoute.name === 'Datasets') {
      this.text = this.searchDatasetsFilter;
    }
  },

  methods: {
    ...mapMutations(['RESET_CANCELLABLE_SEARCH_REQUEST']),
    ...mapMutations('pagination', ['SET_CURRENT_PAGE'])
  }
}
</script>
